/* tokscan.c -- Token scanning engine
 *
 * See tokscan.h for details
 */

#include "stddefs.h"
#include "tokscan.h"
#include "tokenlst.h"

/* -- Exported functions -- */

tokenList *ReadLineTokens(FILE *ifile, bool *inFile)
{
	char	buffer[MAXSTRING * 4];

	ReadLineText(ifile, buffer, MAXSTRING * 4, inFile);

	return GetTokens(buffer);
}

void ReadLineText(FILE *ifile, char *buffer, unsigned length, bool *inFile)
{
	char			read;							/* Character read from 'file' */
	unsigned		count;						/* number of characters in 'buffer' */

   count = 0;

   fread(&read, 1, 1, ifile);

   while (read != EOL && *inFile) {
      if (feof(ifile))
      	*inFile = FALSE;

		else {
			*buffer++ = read;
			count++;

			if (count == length - 1)		/* Filled the buffer */
				break;
		}

		fread(&read, 1, 1, ifile);
	}

	*buffer = EOS;
}



/* --- END of TokScan.c --- */